#include <stdio.h>
#include <stdlib.h>

int main()
{
    int N, K;
    scanf("%i %i",&N,&K);
    int a[N];
    int x = 0, y = N - 1;

    for(int i = 0; i<N; i++){
        scanf("%i",&a[i]);
    }

    for(int i = 0; i<K-1; i++){
        if(a[x] - a[y] >= a[y] - a[x]){
            a[x] = a[x] - a[y];
            y--;
        }else if(a[x] - a[y] < a[y] - a[x]){
            a[y] = a[y] - a[x];
            x++;
        }
    }
    if(a[x] < a[y])
        printf("%i",a[x]);
    else
        printf("%i",a[y]);

    return 0;
}